package com.mortals.xhx.module.device.web;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.module.device.model.DeviceMatterDatumQuery;
import com.mortals.xhx.module.matter.model.MatterDatumEntity;
import com.mortals.xhx.module.matter.model.MatterDatumQuery;
import com.mortals.xhx.module.matter.service.MatterDatumService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.device.model.DeviceMatterDatumEntity;
import com.mortals.xhx.module.device.service.DeviceMatterDatumService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.*;
import java.util.stream.Collectors;
import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import static com.mortals.framework.ap.SysConstains.*;
/**
*
* 设备事项申请材料业务
*
* @author zxfei
* @date 2023-02-25
*/
@RestController
@RequestMapping("device/matter/datum")
public class DeviceMatterDatumController extends BaseCRUDJsonBodyMappingController<DeviceMatterDatumService,DeviceMatterDatumEntity,Long> {

    @Autowired
    private ParamService paramService;

    @Autowired
    private MatterDatumService matterDatumService;

    public DeviceMatterDatumController(){
        super.setModuleDesc( "设备事项申请材料业务");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "source", paramService.getParamBySecondOrganize("DeviceMatterDatum","source"));
        this.addDict(model, "isRecommend", paramService.getParamBySecondOrganize("DeviceMatterDatum","isRecommend"));
        super.init(model, context);
    }


    @Override
    protected void batchSaveBefore(List<DeviceMatterDatumEntity> list, Map<String, Object> model, Context context) throws AppException {
        Iterator<DeviceMatterDatumEntity> iterator = list.iterator();
        while (iterator.hasNext()) {
            DeviceMatterDatumEntity next = iterator.next();
            int count = this.service.getDao().getCount(new DeviceMatterDatumQuery().deviceId(next.getDeviceId()).matterId(next.getMatterId()));
            if(count>0){
                iterator.remove();
            }
        }

        super.batchSaveBefore(list, model, context);
    }

    @Override
    protected int infoAfter(Long id, Map<String, Object> model, DeviceMatterDatumEntity entity, Context context) throws AppException {
        List<MatterDatumEntity> matterDatumEntities = matterDatumService.find(new MatterDatumQuery().matterId(entity.getMatterId()));
        entity.setMatterDatumList(matterDatumEntities);
        return super.infoAfter(id, model, entity, context);
    }
}